#ifndef INCLUDES_AND_SETTINGS_H_
#define INCLUDES_AND_SETTINGS_H_


#define NUMBER_OF_BUFFERS 10            /* each direction so double this for the total */
#define MINIMUM_BUFFER_LENGTH 1
#define MAXIMUM_BUFFER_LENGTH 3095     /* set this to the same value as the min for a fixed size, also don't exceed 65535 */

/* Making sure that there will be enough space for code (maximum of 1.5MB) */
#if ((2 * NUMBER_OF_BUFFERS * MAXIMUM_BUFFER_LENGTH) > 1572864)
  #error Your total buffer space has exceeded the limit.  Please reduce the\
         buffer space so that there is enough room to hold Nios II code.
#endif

/* prototypes to include in the main file */
alt_u32 create_descriptors(alt_sgdma_descriptor ** transmit_descriptors_p,
                      alt_sgdma_descriptor ** transmit_descriptors_copy_p,
                      alt_sgdma_descriptor ** receive_descriptors_p,
                      alt_sgdma_descriptor ** receive_descriptors_copy_p,
                      alt_8 ** input_buffers,
                      alt_16 ** output_buffers,
                      alt_u16 * buffer_lengths,
                      alt_u32 number_of_buffers);

alt_u32 create_test_data(alt_8  *** input_buffers_p,
                         alt_16 *** output_buffers_p,
                         alt_u16 ** buffer_lengths_p,
                         alt_u16 number_of_buffers,
                         alt_u16 minimum_buffer_length,
                         alt_u16 maximum_buffer_length);

alt_u32 linear_function_hw(alt_sgdma_dev * transmit_DMA,
		                alt_sgdma_descriptor * transmit_descriptors,
		                volatile alt_u16 * tx_done_p,
		                alt_sgdma_dev * receive_DMA,
                        alt_sgdma_descriptor * receive_descriptors,
                        volatile alt_u16 * rx_done_p,
                        alt_8 param_a,
                        alt_8 param_b);

alt_u32 linear_function_sw(alt_8  ** input_buffers,
                           alt_16 ** output_buffers,
                           alt_u16 * buffer_lengths,
                           alt_u16 number_of_buffers,
                           alt_8 param_a,
                           alt_8 param_b);

void validate_hw_results(alt_sgdma_descriptor * transmit_descriptors,
                         alt_sgdma_descriptor * receive_descriptors,
                         alt_u32 number_of_buffers,
                         alt_8 param_a,
                         alt_8 param_b);


#endif /*INCLUDES_AND_SETTINGS_H_*/
